// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int t = opt<int>("t");
	int minn = 1, maxn = 1;
	if (has_opt("maxn")) {
		maxn = opt<int>("maxn");
	}
	if (has_opt("n")) {
		minn = maxn = opt<int>("n");
	}

	int minm = 1, maxm = 1;
	if (has_opt("maxm")) {
		maxm = opt<int>("maxm");
	}
	if (has_opt("m")) {
		minm = maxm = opt<int>("m");
	}
	double p = opt<double>("p");

	cout << t << "\n";
	for (int tn = 1; tn <= t; ++tn) {
		setTestCase(tn);
		int n = rnd.next(minn, maxn);
		int m = rnd.next(minm, maxm);
		cout << n << " " << m << "\n";
		vector<vector<bool>> field(n, vector<bool>(m));
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				field[i][j] = rnd.next() < p;
			}
		}

		if (has_opt("add_stripes")) {
			for (int i = 0; i < opt<int>("add_stripes"); ++i) {
				if (rnd.next() < 0.5) {
					int x = rnd.next(0, n - 1);
					int len = rnd.next(1, m);
					int y1 = rnd.next(0, m - len);
					for (int j = 0; j < len; ++j) {
						field[x][y1 + j] = 1;
					}
				} else {
					int y = rnd.next(0, m - 1);
					int len = rnd.next(1, n);
					int x1 = rnd.next(0, n - len);
					for (int j = 0; j < len; ++j) {
						field[x1 + j][y] = 1;
					}
				}
			}
		}

		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				if (field[i][j]) {
					cout << ".";
				} else {
					cout << "#";
				}
			}
			cout << "\n";
		}
	}

	return 0;
}